/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsProtoIp.h
    
Abstract:

    Incude header files for protocol IP

--*/

#ifndef __EMS_IP_H__
#define __EMS_IP_H__

#include "EmsTclInit.h"
#include "EmsTypes.h"
#include "EmsProtocols.h"

extern PROTOCOL_ENTRY_T IpProtocol;
extern UINT32           LocalIp;
extern UINT32           RemoteIp;

typedef struct _IP_HEADER {
  UINT8   IpIhl : 4,  /* Internet header length */
  IpVer : 4;          /* version */
  UINT8   IpTos;      /* type of service */
  UINT16  IpLen;      /* total length */
  UINT16  IpId;       /* identification */
  UINT16  IpFrag;     /* fragment information */
  UINT8   IpTtl;      /* time to live */
  UINT8   IpProto;    /* next level protocol */
  UINT16  IpSum;      /* checksum on header */
  UINT32  IpSrc;      /* source ip address */
  UINT32  IpDst;      /* destination ip address */
} IP_HEADER;

UINT16
GetIpId (
  VOID_P
  )
/*++

Routine Description:

  Get a IP Id

Arguments:

  None

Returns:

  Return the IP Id

--*/
;

#endif
