/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsUtilityMain.c
    
Abstract:

    Implementation of Ents utility commands  

--*/

#include "EmsTypes.h"
#include "EmsUtilityMain.h"
#include "tcl.h"

STATIC TCL_CMD_TBL  TclUtilityCmd[] = {
  {
    "Stall",
    TclStall
  },
  {
    "Include",
    TclInclude
  },
  {
    "SetCaseRoot",
    TclSetCaseRoot
  },
  {
    NULL,
    NULL
  }
};

VOID_P
UtilityTclInit (
  Tcl_Interp        *Interp
  )
/*++

Routine Description:

  Packet capture related TCL initialization.

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
{
  UINT32  Index;
  //
  // Create internal TCL commands
  //
  for (Index = 0; TclUtilityCmd[Index].Cmd; Index++) {
    Tcl_CreateCommand (
      Interp,
      TclUtilityCmd[Index].Cmd,
      TclUtilityCmd[Index].Proc,
      (ClientData) NULL,
      (Tcl_CmdDeleteProc *) NULL
      );
  }

  return ;
}
