/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsRivlFunc.h
    
Abstract:

    Include file of RIVL function related functions

--*/

#ifndef _RIVL_FUNC_H_
#define _RIVL_FUNC_H_

#include "EmsRivlMain.h"

RIVL_FUNCTION *
RivlFunctionFindByName (
  INT8 *Name
  )
/*++

Routine Description:

  Find a Rivl function type's variable accroding to name

Arguments:

  Name  - 

Returns:

  return the found variable

--*/
;

BOOLEAN
FunctionExist (
  INT8 *Name
  )
/*++

Routine Description:

  Check whether the Rivl function type's variable is exist

Arguments:

  Name  - The name of the Rivl function

Returns:

  TRUE or FALSE

--*/
;

VOID_P
RivlFunctionRemoveByName (
  INT8 *Name
  )
/*++

Routine Description:

  Remove a Rivl function type's variable accroding to name

Arguments:

  Name  - The name of the function

Returns:

  None

--*/
;

VOID_P
RivlFunctionDestroy (
  RIVL_FUNCTION *func
  )
/*++

Routine Description:

  Destroy a Rivl function

Arguments:

  Func  - The pointer to a Rivl function

Returns:

  None

--*/
;

VOID_P
RivlFunctionAdd (
  RIVL_FUNCTION *func
  )
/*++

Routine Description:

  Add a new Rivl function

Arguments:

  Func  - The pointer to a Rivl function

Returns:

  None

--*/
;

VOID_P
RivlFunctionRemoveAll (
  VOID_P
  )
/*++

Routine Description:

  Remove all the Rivl functions

Arguments:

  None

Returns:

  None

--*/
;

#endif
