/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsTclInit.h
    
Abstract:

    Incude header files for TCL related functions

--*/

#ifndef __EMS_TCL_H__
#define __EMS_TCL_H__

#include <tcl.h>
#include "EmsTypes.h"
#ifdef WITH_GUI
#include <tk.h>
#endif
//
// Structure definition for command table
//
typedef struct _TCL_CMD_TBL {
  INT8        *Cmd;
  Tcl_CmdProc *Proc;
} TCL_CMD_TBL;

INT32
EmsGuiInterpInit (
  IN Tcl_Interp *Interp
  )
/*++

Routine Description:

  The EMS GUI intepreter's initialization

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

VOID_P
RpcTclInit (
  Tcl_Interp *Interp
  )
/*++

Routine Description:

  Initialize the EMS RPC

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

INT32
EmsTestInterpInit (
  Tcl_Interp  *Interp
  )
/*++

Routine Description:

  The EMS test intepreter's initialization

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

extern Tcl_Interp *TestCaseInterp;
extern Tcl_Interp *GuiInterp;

#endif
