/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsUtilityMain.h
    
Abstract:

    Incude header files for utility functions

--*/

#ifndef _EMS_UTILITY_H_
#define _EMS_UTILITY_H_

#include "EmsMain.h"
#include "EmsTypes.h"
#include "EmsTclInit.h"
#include "EmsUtilityString.h"
#include "EmsLogCommand.h"

#ifndef MAX_DIR_LEN
#define MAX_DIR_LEN 1024
#endif

extern Tcl_CmdProc  TclStall;
extern Tcl_CmdProc  TclInclude;
extern Tcl_CmdProc  TclSetCaseRoot;

VOID_P
UtilityTclInit (
  IN Tcl_Interp *Interp
  )
/*++

Routine Description:

  Utility related TCL initialization.

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

#endif
