/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  EntsProtocol.h

Abstract:

--*/

#ifndef _ENTS_PROTOCOL_H_
#define _ENTS_PROTOCOL_H_

#include "Efi.h"

#define EFI_ENTS_PROTOCOL_GUID \
  { \
    0x5bfcffb2, 0x84c0, 0x49f0, 0x9a, 0x3a, 0x0, 0x71, 0x5f, 0xec, 0xfb, 0x32 \
  }

extern EFI_GUID gEfiEntsProtocolGuid;

#define ENTS_PROTOCOL_ATTRIBUTE_BOOT_SERVICE                      1
#define ENTS_PROTOCOL_ATTRIBUTE_RUNTIME_SERVICE                   2
#define ENTS_PROTOCOL_ATTRIBUTE_GENERIC_SERVICE                   4
#define ENTS_PROTOCOL_ATTRIBUTE_PROTOCOL                          8
#define ENTS_PROTOCOL_ATTRIBUTE_PROTOCOL_SERVICE_BINDING_RELATED  9

typedef
EFI_STATUS
(EFIAPI *ENTS_INTERFACE_ENTRY) (
  IN VOID                      *ClientInterface
  );

typedef struct _ENTS_ARG_FIELD {
  UINTN Type;
  VOID  *Data;
} ENTS_ARG_FIELD;

typedef struct _ENTS_INTERFACE {
  CHAR16                *InterfaceName;
  ENTS_INTERFACE_ENTRY  EntsInterfaceEntry;
  ENTS_ARG_FIELD        *ArgFieldList;
} ENTS_INTERFACE;

typedef struct _EFI_ENTS_PROTOCOL {
  UINTN           Revision;
  VOID            *ClientName;
  UINTN           ClientAttribute;
  EFI_GUID        *ClientGuid;
  EFI_HANDLE      ClientHandle;
  VOID            *ClientInterface;
  ENTS_INTERFACE  *EntsInterfaceList;
  CHAR16          *RuntimeInfo;
  UINTN           RuntimeInfoSize;
} EFI_ENTS_PROTOCOL;

#endif // _ENTS_PROTOCOL_H_
