/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein.

Module Name:

  MiscellaneousBootENTSTestCase.c

Abstract:

--*/

#include "MiscellaneousBootENTSTestCase.h"

//
// gBS.SetWatchdogTimer
//
static UINTN      BSSetWatchdogTimerTimeout;
static UINT64     BSSetWatchdogTimerWatchdogCode;
static UINTN      BSSetWatchdogTimerDataSize;
static CHAR16     *BSSetWatchdogTimerWatchdogData;
static EFI_STATUS *BSSetWatchdogTimerStatus;

ENTS_ARG_FIELD    gBSSetWatchdogTimerArgField[] = {
  {
    OCTETN,
    &BSSetWatchdogTimerTimeout
  },
  {
    OCTET8,
    &BSSetWatchdogTimerWatchdogCode
  },
  {
    OCTETN,
    &BSSetWatchdogTimerDataSize
  },
  {
    POINTER,
    &BSSetWatchdogTimerWatchdogData
  },
  {
    POINTER,
    &BSSetWatchdogTimerStatus
  },
  0
};

EFI_STATUS
BS_SetWatchdogTimer_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 SetWatchdogTimer Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_BOOT_SERVICES *BootService;

  BootService = (EFI_BOOT_SERVICES *) ClientInterface;

  *BSSetWatchdogTimerStatus = BootService->SetWatchdogTimer (
                                            BSSetWatchdogTimerTimeout,
                                            BSSetWatchdogTimerWatchdogCode,
                                            BSSetWatchdogTimerDataSize,
                                            BSSetWatchdogTimerWatchdogData
                                            );
  return EFI_SUCCESS;
}

//
// gBS.Stall
//
static UINTN      BSStallMicroseconds;
static EFI_STATUS *BSStallStatus;

ENTS_ARG_FIELD    gBSStallArgField[] = {
  {
    OCTETN,
    &BSStallMicroseconds
  },
  {
    POINTER,
    &BSStallStatus
  },
  0
};

EFI_STATUS
BS_Stall_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 Stall Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_BOOT_SERVICES *BootService;

  BootService     = (EFI_BOOT_SERVICES *) ClientInterface;

  *BSStallStatus  = BootService->Stall (BSStallMicroseconds);
  return EFI_SUCCESS;
}

//
// gBS.CopyMem
//
static VOID     *BSCopyMemDestination;
static VOID     *BSCopyMemSource;
static UINTN    BSCopyMemLength;

ENTS_ARG_FIELD  gBSCopyMemArgField[] = {
  {
    POINTER,
    &BSCopyMemDestination
  },
  {
    POINTER,
    &BSCopyMemSource
  },
  {
    OCTETN,
    &BSCopyMemLength
  },
  0
};

EFI_STATUS
BS_CopyMem_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 CopyMem Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_BOOT_SERVICES *BootService;

  BootService = (EFI_BOOT_SERVICES *) ClientInterface;

  BootService->CopyMem (
                BSCopyMemDestination,
                BSCopyMemSource,
                BSCopyMemLength
                );
  return EFI_SUCCESS;
}

//
// gBS.SetMem
//
static VOID     *BSSetMemBuffer;
static UINTN    BSSetMemSize;
static UINT8    BSSetMemValue;

ENTS_ARG_FIELD  gBSSetMemArgField[] = {
  {
    POINTER,
    &BSSetMemBuffer
  },
  {
    OCTETN,
    &BSSetMemSize
  },
  {
    OCTET1,
    &BSSetMemValue
  },
  0
};

EFI_STATUS
BS_SetMem_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 SetMem Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_BOOT_SERVICES *BootService;

  BootService = (EFI_BOOT_SERVICES *) ClientInterface;

  BootService->SetMem (
                BSSetMemBuffer,
                BSSetMemSize,
                BSSetMemValue
                );
  return EFI_SUCCESS;
}
