/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein. 

Module Name:

  VariableENTSTestCase.c

Abstract:

--*/

#include "VariableENTSTestCase.h"

//
// RT.GetVariable
//
static CHAR16     *RTGetVariableVariableName;
static EFI_GUID   *RTGetVariableVendorGuid;
static UINT32     *RTGetVariableAttributes;
static UINTN      *RTGetVariableDataSize;
static VOID       *RTGetVariableData;
static EFI_STATUS *RTGetVariableStatus;

ENTS_ARG_FIELD    gRTGetVariableArgField[] = {
  {
    POINTER,
    &RTGetVariableVariableName
  },
  {
    POINTER,
    &RTGetVariableVendorGuid
  },
  {
    POINTER,
    &RTGetVariableAttributes
  },
  {
    POINTER,
    &RTGetVariableDataSize
  },
  {
    POINTER,
    &RTGetVariableData
  },
  {
    POINTER,
    &RTGetVariableStatus
  },
  0
};

EFI_STATUS
RT_GetVariable_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  RT GetVariable Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_RUNTIME_SERVICES  *RuntimeService;

  RuntimeService = (EFI_RUNTIME_SERVICES *) ClientInterface;

  *RTGetVariableStatus = RuntimeService->GetVariable (
                                          RTGetVariableVariableName,
                                          RTGetVariableVendorGuid,
                                          RTGetVariableAttributes,
                                          RTGetVariableDataSize,
                                          RTGetVariableData
                                          );
  return EFI_SUCCESS;
}

//
// RT.GetNextVariableName
//
static UINTN      *RTGetNextVariableNameVariableNameSize;
static CHAR16     *RTGetNextVariableNameVariableName;
static EFI_GUID   *RTGetNextVariableNameVendorGuid;
static EFI_STATUS *RTGetNextVariableNameStatus;

ENTS_ARG_FIELD    gRTGetNextVariableNameArgField[] = {
  {
    POINTER,
    &RTGetNextVariableNameVariableNameSize
  },
  {
    POINTER,
    &RTGetNextVariableNameVariableName
  },
  {
    POINTER,
    &RTGetNextVariableNameVendorGuid
  },
  {
    POINTER,
    &RTGetNextVariableNameStatus
  },
  0
};

EFI_STATUS
RT_GetNextVariableName_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  GetNextVariableName Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_RUNTIME_SERVICES  *RuntimeService;

  RuntimeService = (EFI_RUNTIME_SERVICES *) ClientInterface;

  *RTGetNextVariableNameStatus = RuntimeService->GetNextVariableName (
                                                  RTGetNextVariableNameVariableNameSize,
                                                  RTGetNextVariableNameVariableName,
                                                  RTGetNextVariableNameVendorGuid
                                                  );
  return EFI_SUCCESS;
}

//
// RT.SetVariable
//
static CHAR16     *RTSetVariableVariableName;
static EFI_GUID   *RTSetVariableVendorGuid;
static UINT32     RTSetVariableAttributes;
static UINTN      RTSetVariableDataSize;
static VOID       *RTSetVariableData;
static EFI_STATUS *RTSetVariableStatus;

ENTS_ARG_FIELD    gRTSetVariableArgField[] = {
  {
    POINTER,
    &RTSetVariableVariableName
  },
  {
    POINTER,
    &RTSetVariableVendorGuid
  },
  {
    OCTET4,
    &RTSetVariableAttributes
  },
  {
    OCTETN,
    &RTSetVariableDataSize
  },
  {
    POINTER,
    &RTSetVariableData
  },
  {
    POINTER,
    &RTSetVariableStatus
  },
  0
};

EFI_STATUS
RT_SetVariable_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SetVariable Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_RUNTIME_SERVICES  *RuntimeService;

  RuntimeService = (EFI_RUNTIME_SERVICES *) ClientInterface;

  *RTSetVariableStatus = RuntimeService->SetVariable (
                                          RTSetVariableVariableName,
                                          RTSetVariableVendorGuid,
                                          RTSetVariableAttributes,
                                          RTSetVariableDataSize,
                                          RTSetVariableData
                                          );
  return EFI_SUCCESS;
}
