/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  ProtocolDefinition.c

Abstract:

  Protocols that will be used during the Image Boot Services Test

--*/

#include "ProtocolDefinition.h"

//
// module globals
//
EFI_GUID mImageTestNoInterfaceProtocol1Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_1_GUID;
EFI_GUID mImageTestNoInterfaceProtocol2Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_2_GUID;
EFI_GUID mImageTestNoInterfaceProtocol3Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_3_GUID;
EFI_GUID mImageTestNoInterfaceProtocol4Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_4_GUID;
EFI_GUID mImageTestNoInterfaceProtocol5Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_5_GUID;
EFI_GUID mImageTestNoInterfaceProtocol6Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_6_GUID;
EFI_GUID mImageTestNoInterfaceProtocol7Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_7_GUID;
EFI_GUID mImageTestNoInterfaceProtocol8Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_8_GUID;
EFI_GUID mImageTestNoInterfaceProtocol9Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_9_GUID;
EFI_GUID mImageTestNoInterfaceProtocol10Guid = IMAGE_TEST_NO_INTERFACE_PROTOCOL_10_GUID;

EFI_GUID mImageTestForLoadFileProtocol1Guid = IMAGE_TEST_FOR_LOAD_FILE_PROTOCOL_1_GUID;

EFI_GUID mImageTestVariableVendorGuid       = IMAGE_TEST_VARIABLE_VENDOR_GUID;

EFI_GUID mImageTestVendorDevicePath1Guid = IMAGE_TEST_VENDOR_DEVICE_PATH_1_GUID;

EFI_GUID mImageTestLoadFileDriverPathGuid       = IMAGE_TEST_LOAD_FILE_DRIVER_PATH_GUID;
EFI_GUID mImageTestLoadFileApplicationPathGuid  = IMAGE_TEST_LOAD_FILE_APPLICATION_PATH_GUID;
EFI_GUID mImageTestLoadFileBootPathGuid         = IMAGE_TEST_LOAD_FILE_BOOT_PATH_GUID;
EFI_GUID mImageTestLoadFileRuntimePathGuid      = IMAGE_TEST_LOAD_FILE_RUNTIME_PATH_GUID;

#if (EFI_SPECIFICATION_VERSION >= 0x0002000A)
EFI_GUID  mValidHiiImage1Guid = VALID_HII_IMAGE_1_GUID;
EFI_GUID gEfiHIIPackageListProtocolGuid = EFI_HII_PACKAGE_LIST_PROTOCOL_GUID;
EFI_GUID gEfiHIIDatabaseProtocolGuid = EFI_HII_DATABASE_PROTOCOL_GUID;
#endif
