/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

    HIIPackageListImage.c
    
Abstract:

    Contain some package list images.

Revision History

--*/

#include "HIIFontBBTestMain.h" 

UINT8 mPackageList1[] = {                                                                         
  //                                                                                             
  // EFI_HII_PACKAGE_LIST_HEADER.
  // SimpleFont; Font; GUID, Image, DevicePath, KeyboardLayout
  //                                                                                             
  0x89, 0xcd, 0xab, 0x03, 0xf4, 0x03, 0x44, 0x70, 0x81, 0xde, 0x99, 0xb1, 0x81, 0x20, 0xf7, 0x68,    //PackageListGuid
  0xb5, 0x01, 0x00, 0x00,    // PackageListLength 4
  
  //                                                                                             
  // Simple Font Package 1, length = 74. 
  // 
  //
  // EFI_HII_PACKAGE_HEADER
  //
  0x4A, 0x00, 0x00,    // Package Length 3
  EFI_HII_PACKAGE_SIMPLE_FONTS,    //Package Type 1                                                              
  1, 0,    // Num of Narrow Glyph 2 
  1, 0,    // Num of Wide Glyph 2
  0x55, 0x0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,  //EFI_NARROW_GLYPH (UnicodeWeight 2, Attribute 1, GlyphCol1[19])
  0x77, 0x0, 0x2, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
  3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 0, 0, 0,  //EFI_WIDE_GLYPH(.UnicodeWeight 2, Attribute 1, GlyphCol1[19], GlyphCol1219], Pad[3]) 
  
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //
  // Font Package 1, length = 111.   
  //               
  0x6F, 0x00, 0x00,    // Package Length 3
  EFI_HII_PACKAGE_FONTS,    // Package Type 1
  0x5A, 0x00, 0x00, 0x00,    // header size 4 
  0x5A, 0x00, 0x00, 0x00,    // GlyphBlockOffset  4      
  0x08,0x00, 0x13,0x00, 0x00,0x00, 0x00,0x00, 0x08,0x00,    //EFI_HII_GLYPH_INFO (Width, Height, OffsetX, OffsetY, AdvanceX) 10
  0x01,0x00, 0x00, 0x00,    // EFI_HII_FONT_STYLE 4
  0x77,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x52,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 
  0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x66,  //FontFamily The Null-terminated string with the name of the font family to which the font belongs. 64// BUGBUG
  //
  // Glyph block  1
  //
  // 
  //  EFI_HII_GLYPH_BLOCK
  //
  EFI_HII_GIBT_GLYPH_DEFAULT, // BlockType 1  
  0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x99, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22,//19, BitMapData
  EFI_HII_GIBT_END, //1
  
  
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
  //
  // Guid Package 1. Length = 20.    tested
  //
  0x14, 0x00, 0x00,    // PackageLength 3
  EFI_HII_PACKAGE_TYPE_GUID,   // Package Type  1
  0x5a, 0xc9, 0x87, 0x03, 0x3, 0xd7, 0x46, 0x23, 0xb2, 0xab, 0xd0, 0xc7, 0xdd, 0x90, 0x44, 0xf8, // EFI_GUID 16
      
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //
  // Image Package. Length = 16. 
  //
  0x10, 0x00, 0x00, // PackageLength 3
  EFI_HII_PACKAGE_IMAGES,    // Package Type  1
  0x0c, 0x00, 0x00, 0x00,    // image info offset 4. relatice to this header. If this is zero, then there are no palettes in the image package
  0x00, 0x00, 0x00, 0x00,    // palette info offset 4. relatice to this header. If this is zero, then there are no palettes in the image package
  //
  // Image block 1
  //
  EFI_HII_IIBT_DUPLICATE,    // BlockType 1
  0x01, 0x00,    // image id 2  ???
  EFI_HII_IIBT_END,    //1
  
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //
  // EFI_HII_PACKAGE_DEVICE_PATH length = 8.
  //
//  0x08, 0x00, 0x00,    // PackageLength 3
//  EFI_HII_PACKAGE_DEVICE_PATH,    // Package Type  1
//  0x01, 0x23, 0x45, 0x66, // dummy device path protocol instance address 4 //BUGBUG

  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //
  // Keyboard layout package. Length 
  0xc0, 0x00, 0x00,    // PackageLength 3
  EFI_HII_PACKAGE_KEYBOARD_LAYOUT,    // Package Type  1
  0x02, 0x00, //2, LayoutCount
  //
  // Layout 1
  //
  0x5d, 0x00, // layout length 2
  0x1f, 0x6a, 0xf5, 0xe0, 0x6b, 0xdf, 0x7e, 0x4a, 0xa3, 0x9a, 0xe7, 0xa5, 0x19, 0x15, 0x45, 0xd6, //16, GUID
  0x37, 0x00, 0x00, 0x00, //layout descriptor string offset 4
  0x02, // Descriptor count 1
  //
  // Descriptor 1, 16 bytes,
  //
  EfiKeyC1, 0x00, 0x00, 0x00, // 4 
  'a', 0x00,
  'A', 0x00,
  0x00, 0x00,
  0x00, 0x00,
  EFI_NULL_MODIFIER,0x00,
  0x03, 0x00, // affected attributes
  //
  // Descriptor 2,  16 bytes
  //
  EfiKeyC2, 0x00, 0x00, 0x00,
  's', 0x00,
  'S', 0x00,
  0x00, 0x00,
  0x00, 0x00,
  EFI_NULL_MODIFIER, 0x00,
  0x03, 0x00,
  //
  // EFI_DESCRIPTOR_STRING_BUNDLE
  //
  0x01, 0x00,                 // DescriptionCount 2
  'e', 0x0, 'n', 0x0, '-', 0x0, 'U', 0x0, 'S', 0x0,  // RFC3066 language code 10
  ' ', 0x0,                        // Space 2
  'S', 0x0, 'i', 0x0, 'm', 0x0, 'p', 0x0, 'l', 0x0, 'e', 0x0, '1', 0x0, 'o', 0x0, 'n', 0x0, 'l', 0x0, 'y', 0x0, '\0', 0x0, // DescriptionString  24
  
  //
  // Layout 2
  //  
  0x5d, 0x00, // layout length 2
  0xc9, 0x6a, 0xbe, 0x47, 0xcc, 0x54, 0xf9, 0x46, 0xa2, 0x62, 0xd5, 0x3b, 0x25, 0x6a, 0xc, 0x34, //16, GUID
  0x37, 0x00, 0x00, 0x00, //layout descriptor string offset 4
  0x02,  // Descriptor count 1
  //
  // Descriptor 1, 16 bytes,
  //
  EfiKeyC3, 0x0, 0x0, 0x0,
  'd', 0x00,
  'D', 0x00,
  0x00, 0x00,
  0x00, 0x00,
  EFI_NULL_MODIFIER, 0x0,
  0x03, 0x00,
  //
  // Descriptor 2,  16 bytes
  //
  EfiKeyC4, 0x0, 0x0, 0x0,
  'e', 0x00,
  'E', 0x00,
  0x00, 0x00,
  0x00, 0x00,
  EFI_NULL_MODIFIER,  0x0,
  0x03, 0x00,
  //
  // EFI_DESCRIPTOR_STRING_BUNDLE
  //
  0x01, 0x00,                 // DescriptionCount 2
  'e', 0x0, 'n', 0x0, '-', 0x0, 'U', 0x0, 'S', 0x0,  // RFC3066 language code 10
  ' ', 0x0,                        // Space 2
  'S', 0x0, 'i', 0x0, 'm', 0x0, 'p', 0x0, 'l', 0x0, 'e', 0x0, '2', 0x0, 'o', 0x0, 'n', 0x0, 'l', 0x0, 'y', 0x0, '\0', 0x0, // DescriptionString  24
  
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //
  // End of package list, length = 4,
  //
  0x4, 0x00, 0x00,
  EFI_HII_PACKAGE_END                                                                                    
};
