/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

    iScsiInitiatorNameBBTestMain.c

Abstract:

    IscsiInitiatorName Protocol (define according to the UEFI Spec 2.0 )

Revision History

--*/

#include "iScsiInitiatorNameBBTestMain.h"
#include "EfiTestLib.h"

EFI_BB_TEST_PROTOCOL_FIELD gBBTestProtocolField = {
  ISCSI_INITIATOR_NAME_PROTOCOL_TEST_REVISION,
  EFI_ISCSI_INITIATOR_NAME_PROTOCOL_GUID,
  L"ISCSI Initiator Name Protocol", 
  L"UEFI 2.0 ISCSI Initiator Name protocol"
};

EFI_GUID gSupportProtocolGuid1[2] = {
  EFI_STANDARD_TEST_LIBRARY_GUID,
  EFI_NULL_GUID
};

EFI_BB_TEST_ENTRY_FIELD gBBTestEntryField[] = {
  {
    ISCSI_INITIATORNAME_PROTOCOL_GET_FUNCTION_GUID,
    L"Get_Func",
    L"Invoke Get() and verify interface correctness within test case",
    EFI_TEST_LEVEL_DEFAULT,
    gSupportProtocolGuid1,
    EFI_TEST_CASE_AUTO,
    BBTestGetFunctionTest
  },

  {
    ISCSI_INITIATORNAME_PROTOCOL_SET_FUNCTION_GUID,
    L"Set_Func",
    L"Invoke Set() and verify interface correctness within test case",
    EFI_TEST_LEVEL_DEFAULT,
    gSupportProtocolGuid1,
    EFI_TEST_CASE_AUTO,
    BBTestSetFunctionTest
  },

  {
    ISCSI_INITIATORNAME_PROTOCOL_GET_CONFORMANCE_GUID,
    L"Get_Conf",
    L"Test whether Get() performs enough parameter checking",
    EFI_TEST_LEVEL_DEFAULT,
    gSupportProtocolGuid1,
    EFI_TEST_CASE_AUTO,
    BBTestGetConformanceTest
  },

  {
    ISCSI_INITIATORNAME_PROTOCOL_SET_CONFORMANCE_GUID,
    L"Set_Conf",
    L"Test whether Set() performs enough parameter checking",
    EFI_TEST_LEVEL_DEFAULT,
    gSupportProtocolGuid1,
    EFI_TEST_CASE_AUTO,
    BBTestSetConformanceTest
  },

  0
};

EFI_BB_TEST_PROTOCOL *gBBTestProtocolInterface;

EFI_STATUS
BBTestiScsiInitiatorNameProtocolUnload (
  IN EFI_HANDLE       ImageHandle
  );

EFI_DRIVER_ENTRY_POINT(InitializeBBTestiScsiInitiatorName)

EFI_STATUS
InitializeBBTestiScsiInitiatorName (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  )
{
  EfiInitializeTestLib (ImageHandle, SystemTable);
  InitializeLib (ImageHandle, SystemTable);

  return EfiInitAndInstallBBTestInterface (
           &ImageHandle,
           &gBBTestProtocolField,
           gBBTestEntryField,
           BBTestiScsiInitiatorNameProtocolUnload,
           &gBBTestProtocolInterface
           );
}

EFI_STATUS
BBTestiScsiInitiatorNameProtocolUnload (
  IN EFI_HANDLE       ImageHandle
  )
{
  EFI_STATUS Status;

  Status = EfiUninstallAndFreeBBTestInterface (
             ImageHandle,
             gBBTestProtocolInterface
             );

  return Status;
}

