/*++
 Copyright (c) 2008, Byosoft.NJ
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  DriverSupportedEfiVersionBBTestMain.h

Abstract:

  BB test header file of Efi Driver Support Efi Version Protocol

--*/


#ifndef _DRIVER_SUPPORTED_EFI_VERSION_BBTEST_H_
#define _DRIVER_SUPPORTED_EFI_VERSION_BBTEST_H_


#include "Efi.h"
#include "EfiTest.h"
#include "Guid.h"
#include "DriverSupportedEfiVersionProtocol.h"

#include "EfiDriverLib.h"
#include "EfiTestLib.h"
#include "EfiCommonLib.h"
#include "EfiTestUtilityLib.h"



#include EFI_TEST_PROTOCOL_DEFINITION (BBTest)
#include EFI_TEST_PROTOCOL_DEFINITION (StandardTestLibrary)

#define  DRIVER_SUPPORTED_EFI_VERSION_PROTOCOL_TEST_REVISION    0x00010000

#define IHV_DRIVER_SUPPORTED_EFI_VERSION_PROTOCOL_GUID        \
{                  \
        0xcd0463ca, 0x97cf, 0x499b, 0xb9, 0xf3, 0x8c, 0x82, 0x90, 0x9c, 0x7, 0x89       \
}


EFI_STATUS
InitializeBBTestDriverSupportedEfiVersion (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  );

EFI_STATUS
BBTestDriverSupportedEfiVersionProtocolUnload (
  IN EFI_HANDLE           ImageHandle
  );

EFI_STATUS
BBTestLengthParameterAutoTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  );

EFI_STATUS
BBTestFirmwareVersionParameterAutoTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  );

//
// Entry GUIDs
//

#define DRIVER_SUPPORTED_EFI_VERSION_PROTOCOL_LENGTH_PARAMETER_AUTO_GUID \
  { 0xecbbdc3, 0x286b, 0x484c, 0x8b, 0x14, 0x67, 0x90, 0x39, 0x50, 0x97, 0xef }

#define DRIVER_SUPPORTED_EFI_VERSION_PROTOCOL_FIRMWAREVERSION_PARAMETER_AUTO_GUID \
  { 0xc5a6f8f6, 0x8092, 0x4c0e, 0x90, 0xa5, 0x7a, 0x54, 0xee, 0xc0, 0xd3, 0xc3 }

#endif

