/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  SctOutput.h

Abstract:

  This file provides a default test output library.

--*/

#ifndef _EFI_SCT_OUTPUT_H_
#define _EFI_SCT_OUTPUT_H_

#include "Efi.h"
#include "EfiTest.h"
#include EFI_TEST_PROTOCOL_DEFINITION (TestOutputLibrary)

//
// Private interface data structures of TestOutput protocol
//

#define TEST_OUTPUT_PRIVATE_DATA_SIGNATURE  EFI_SIGNATURE_32('T','O','L','I')

#define TEST_OUTPUT_PRIVATE_DATA_REVISION   0x00010000

//
// Forward reference for pure ANSI compatibility
//
EFI_FORWARD_DECLARATION (TEST_OUTPUT_FILE);

typedef struct _TEST_OUTPUT_FILE {
  TEST_OUTPUT_FILE            *Next;
  EFI_DEVICE_PATH_PROTOCOL    *DevicePath;
  CHAR16                      *FileName;
  EFI_FILE_HANDLE             FileHandle;
  UINTN                       OpenCount;
} TEST_OUTPUT_FILE;

typedef struct {
  UINT32                                    Signature;
  EFI_TEST_OUTPUT_LIBRARY_PROTOCOL          TestOutput;
  TEST_OUTPUT_FILE                          *OutputFileList;
} TEST_OUTPUT_PRIVATE_DATA;

#define TEST_OUTPUT_PRIVATE_DATA_FROM_THIS(a) \
  CR(a, TEST_OUTPUT_PRIVATE_DATA, TestOutput, TEST_OUTPUT_PRIVATE_DATA_SIGNATURE)

//
// Global variables
//

extern EFI_TEST_OUTPUT_LIBRARY_PROTOCOL *gOutputProtocol;

#endif
