#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
if {[info exist SIMPLE_NETWORK_INC] == 1} {
  return
}

Include include/EntsProtocolTest.inc.tcl
Include EfiUtil/EFI_inc.tcl

set SIMPLE_NETWORK_INC 1

Func SimpleNetwork->Start {
  POINTER
  }

Func SimpleNetwork->Stop {
  POINTER
  }

Func SimpleNetwork->Initialize {
  UINTN
  UINTN
  POINTER
  }

Func SimpleNetwork->Reset {
  BOOLEAN
  POINTER
  }

Func SimpleNetwork->Shutdown {
  POINTER
  }

Func SimpleNetwork->ReceiveFilters {
  UINT32
  UINT32
  BOOLEAN
  UINTN
  POINTER
  POINTER
  }

Func SimpleNetwork->StationAddress {
  BOOLEAN
  POINTER
  POINTER
  }

Func SimpleNetwork->Statistics {
  BOOLEAN
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->MCastIPtoMAC {
  BOOLEAN
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->NvData {
  BOOLEAN
  UINTN
  UINTN
  POINTER
  POINTER
  }

Func SimpleNetwork->GetStatus {
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->TransmitPattern1 {
  UINTN
  UINTN
  UINTN
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  }


Func SimpleNetwork->TransmitPattern2 {
  UINTN
  UINTN
  UINTN
  UINTN
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->Transmit {
  UINTN
  UINTN
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->ReceivePattern1 {
  UINTN
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->Receive {
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  POINTER
  }

Func SimpleNetwork->Mode {
  POINTER
}
Struct EFI_IPv4_ADDRESS {
  UINT8  Addr(4);
}

Struct EFI_IPv6_ADDRESS {
  UINT8  Addr(16);
}

Union EFI_IP_ADDRESS {
  UINT32           Addr(4);
  EFI_IPv4_ADDRESS v4;
  EFI_IPv6_ADDRESS v6;
}

Struct EFI_MAC_ADDRESS {
  UINT8  Addr(32);
}

Struct EFI_NETWORK_STATISTICS {
  UINT64 RxTotalFrames;
  UINT64 RxGoodFrames;
  UINT64 RxUndersizeFrames;
  UINT64 RxOversizeFrames;
  UINT64 RxDroppedFrames;
  UINT64 RxUnicastFrames;
  UINT64 RxBroadcastFrames;
  UINT64 RxMulticastFrames;
  UINT64 RxCrcErrorFrames;
  UINT64 RxTotalBytes;
  UINT64 TxTotalFrames;
  UINT64 TxGoodFrames;
  UINT64 TxUndersizeFrames;
  UINT64 TxOversizeFrames;
  UINT64 TxDroppedFrames;
  UINT64 TxUnicastFrames;
  UINT64 TxBroadcastFrames;
  UINT64 TxMulticastFrames;
  UINT64 TxCrcErrorFrames;
  UINT64 TxTotalBytes;
  UINT64 Collisions;
  UINT64 UnsupportedProtocol;
}

Struct EFI_SIMPLE_NETWORK_MODE {
  UINT32          State;
  UINT32          HwAddressSize;
  UINT32          MediaHeaderSize;
  UINT32          MaxPacketSize;
  UINT32          NvRamSize;
  UINT32          NvRamAccessSize;
  UINT32          ReceiveFilterMask;
  UINT32          ReceiveFilterSetting;
  UINT32          MaxMCastFilterCount;
  UINT32          MCastFilterCount;
  EFI_MAC_ADDRESS MCastFilter(16);
  EFI_MAC_ADDRESS CurrentAddress;
  EFI_MAC_ADDRESS BroadcastAddress;
  EFI_MAC_ADDRESS PermanentAddress;
  UINT8           IfType;
  BOOLEAN         MacAddressChangeable;
  BOOLEAN         MultipleTxSupported;
  BOOLEAN         MediaPresentSupported;
  BOOLEAN         MediaPresent;
}
